/************************************************************************************/
/*  Program name CAPGLEXT_BALANCES.sql                                              */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 9 JAN, 2005   NIP Karen         First created                                    */
/************************************************************************************/
SET VERIFY OFF
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_BALANCES';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_BALANCES.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		GBL.*
	FROM   
		GL_BALANCES				GBL
    ,	GL_SETS_OF_BOOKS		SOB
	WHERE	GBL.SET_OF_BOOKS_ID	=	SOB.SET_OF_BOOKS_ID
	AND		SUBSTR(SOB.SHORT_NAME,5,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
					C1.SET_OF_BOOKS_ID||CHR(9)||
					C1.CODE_COMBINATION_ID||CHR(9)||
				C1.CURRENCY_CODE||CHR(9)||
				C1.PERIOD_NAME||CHR(9)||
				C1.ACTUAL_FLAG||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
					C1.BUDGET_VERSION_ID||CHR(9)||
				    C1.ENCUMBRANCE_TYPE_ID||CHR(9)||
				C1.TRANSLATED_FLAG||CHR(9)||
				C1.REVALUATION_STATUS||CHR(9)||
				C1.PERIOD_TYPE||CHR(9)||
				C1.PERIOD_YEAR||CHR(9)||
				C1.PERIOD_NUM||CHR(9)||
				C1.PERIOD_NET_DR||CHR(9)||
				C1.PERIOD_NET_CR||CHR(9)||
				C1.PERIOD_TO_DATE_ADB||CHR(9)||
				C1.QUARTER_TO_DATE_DR||CHR(9)||
				C1.QUARTER_TO_DATE_CR||CHR(9)||
				C1.QUARTER_TO_DATE_ADB||CHR(9)||
				C1.YEAR_TO_DATE_ADB||CHR(9)||
				C1.PROJECT_TO_DATE_DR||CHR(9)||
				C1.PROJECT_TO_DATE_CR||CHR(9)||
				C1.PROJECT_TO_DATE_ADB||CHR(9)||
				C1.BEGIN_BALANCE_DR||CHR(9)||
				C1.BEGIN_BALANCE_CR||CHR(9)||
				C1.PERIOD_NET_DR_BEQ||CHR(9)||
				C1.PERIOD_NET_CR_BEQ||CHR(9)||
				C1.BEGIN_BALANCE_DR_BEQ||CHR(9)||
				C1.BEGIN_BALANCE_CR_BEQ||CHR(9)||
				C1.TEMPLATE_ID||CHR(9)||
				C1.ENCUMBRANCE_DOC_ID||CHR(9)||
				C1.ENCUMBRANCE_LINE_NUM||CHR(9)||
				C1.QUARTER_TO_DATE_DR_BEQ||CHR(9)||
				C1.QUARTER_TO_DATE_CR_BEQ||CHR(9)||
				C1.PROJECT_TO_DATE_DR_BEQ||CHR(9)||
				C1.PROJECT_TO_DATE_CR_BEQ||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.SET_OF_BOOKS_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetBudgetName(C1.BUDGET_VERSION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetEncumType(C1.ENCUMBRANCE_TYPE_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/